# -*- coding: utf-8 -*-
from setuphelpers import *

"""
[
    {
        "key": "{5BEE5F3E-4D78-4DE8-A8F3-36D3E9D8868C}",
        "name": "Microsoft Windows Desktop Runtime - 3.1.32 (x64)",
        "version": "24.192.31915",
        "install_date": "2023-11-28 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{5BEE5F3E-4D78-4DE8-A8F3-36D3E9D8868C}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": true,
    },
    {
        "key": "{8A8E3A04-83BC-4CDE-9259-893B666C1AB1}",
        "name": "Microsoft .NET Core Host - 3.1.32 (x64)",
        "version": "24.192.31915",
        "install_date": "2023-11-28 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{8A8E3A04-83BC-4CDE-9259-893B666C1AB1}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": true,
    },
    {
        "key": "{A741B803-3F0E-4684-81EF-FC128D15A92C}",
        "name": "Microsoft .NET Core Runtime - 3.1.32 (x64)",
        "version": "24.192.31915",
        "install_date": "2023-11-28 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{A741B803-3F0E-4684-81EF-FC128D15A92C}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": true,
    },
    {
        "key": "{ABC6B3C2-1A8D-4C5E-AC16-C2AE44F02743}",
        "name": "Microsoft .NET Core Host FX Resolver - 3.1.32 (x64)",
        "version": "24.192.31915",
        "install_date": "2023-11-28 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{ABC6B3C2-1A8D-4C5E-AC16-C2AE44F02743}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": true,
    },
    {
        "key": "{0eddeab6-01c1-4cf7-83ba-164ea8974c90}",
        "name": "Microsoft Windows Desktop Runtime - 3.1.32 (x64)",
        "version": "3.1.32.31915",
        "install_date": "",
        "install_location": "",
        "uninstall_string": '"C:\\ProgramData\\Package Cache\\{0eddeab6-01c1-4cf7-83ba-164ea8974c90}\\windowsdesktop-runtime-3.1.32-win-x64.exe"  /uninstall',
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{25D5B94A-E3CD-44E8-9C3A-FE320B7B38FC}",
        "name": "Microsoft Windows Desktop Runtime - 3.1.32 (x86)",
        "version": "24.192.31915",
        "install_date": "2023-11-28 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{25D5B94A-E3CD-44E8-9C3A-FE320B7B38FC}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{3C73457A-1A33-4DE0-B6C2-6FBA877E1FCF}",
        "name": "Microsoft .NET Core Host - 3.1.32 (x86)",
        "version": "24.192.31915",
        "install_date": "2023-11-28 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{3C73457A-1A33-4DE0-B6C2-6FBA877E1FCF}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{4f894285-fd43-43ac-8669-33e8b7c0a97d}",
        "name": "Microsoft Windows Desktop Runtime - 3.1.32 (x86)",
        "version": "3.1.32.31915",
        "install_date": "",
        "install_location": "",
        "uninstall_string": '"C:\\ProgramData\\Package Cache\\{4f894285-fd43-43ac-8669-33e8b7c0a97d}\\windowsdesktop-runtime-3.1.32-win-x86.exe"  /uninstall',
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{841FE4B1-2C3F-4304-A686-6DF41B4CC1A1}",
        "name": "Microsoft .NET Core Runtime - 3.1.32 (x86)",
        "version": "24.192.31915",
        "install_date": "2023-11-28 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{841FE4B1-2C3F-4304-A686-6DF41B4CC1A1}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{CE1A992F-4571-423D-9CAE-1184E8F29471}",
        "name": "Microsoft .NET Core Host FX Resolver - 3.1.32 (x86)",
        "version": "24.192.31915",
        "install_date": "2023-11-28 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{CE1A992F-4571-423D-9CAE-1184E8F29471}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
]


"""


def install():
    dotnet_version = control.get_software_version().split(".")[0]

    # Installing the software
    silentflags = "/install /quiet /norestart"
    if iswin64():
        install_exe_if_needed(
            glob.glob("windowsdesktop-runtime-*x64.exe")[0],
            silentflags=silentflags,
            name=f"Microsoft Windows Desktop Runtime - {dotnet_version}.*(x64)",
            min_version="",
            force=True,  # force option, since the version is not easy to check, and the installer will take care of it.
        )
    install_exe_if_needed(
        glob.glob("windowsdesktop-runtime-*x86.exe")[0],
        silentflags=silentflags,
        name=f"Microsoft Windows Desktop Runtime - {dotnet_version}.*(x86)",
        min_version="",
        force=True,  # force option, since the version is not easy to check, and the installer will take care of it.
    )

    # Clear uninstallkey to avoid the no-code audit and uninstall
    uninstallkey.clear()


def audit():
    # Declaring local variables
    audit_result = "OK"
    dotnet_version = control.get_software_version().split(".")[0]
    app_check = installed_softwares(name=f"Microsoft Windows Desktop Runtime - {dotnet_version}.*")
    audit_version = True

    # Auditing software
    if not app_check:
        print("%s is not installed" % control.package.split("-", 1)[-1].replace("-", " ").title())
        audit_result = "ERROR"
    elif audit_version:
        for to_audit in app_check:
            if r"ProgramData\Package Cache" in to_audit["uninstall_string"]:
                if Version(to_audit["version"]) < Version(control.get_software_version()):
                    print(f'{to_audit["name"]} is installed in version: {to_audit["version"]} instead of: {control.get_software_version()}.')
                    audit_result = "WARNING"
                else:
                    print("%s is installed and up-to-date." % to_audit["name"])

    return audit_result


def uninstall():
    # Declaring local variables
    dotnet_version = control.get_software_version().split(".")[0]

    for to_uninstall in installed_softwares(name=f"Microsoft Windows Desktop Runtime - {dotnet_version}.*"):
        if r"ProgramData\Package Cache" in to_uninstall["uninstall_string"]:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(ensure_list(control.impacted_process))
            run(uninstall_cmd(to_uninstall["key"]) + " /norestart")
            wait_uninstallkey_absent(to_uninstall["key"])
            if isdir(to_uninstall["install_location"]):
                remove_tree(to_uninstall["install_location"])
